/*
Demonstration of 1 - 4 channel fast quadrature decoder using RP2040 (PicoPi)

2024-03-17
Michael Nowak
http://www.mino-elektronik.de
Alle Angaben ohne Gewaehr !
*/

#ifdef __cplusplus
extern "C" {
#endif
// channel 0
void init_qcnt0(int);
void preload_qcnt0_val(int);
int  get_qcnt0(void);
int  read_qcnt0(void);
void preset_qcnt0(int);
void set_index0_pol(int);
// channel 1
void init_qcnt1(int);
void preload_qcnt1_val(int);
int  get_qcnt1(void);
int  read_qcnt1(void);
void preset_qcnt1(int);
void set_index1_pol(int);
// channel 2
void init_qcnt2(int);
int  get_qcnt2(void);
int  read_qcnt2(void);
void preset_qcnt2(int);
// channel 3
void init_qcnt3(int);
int  get_qcnt3(void);
int  read_qcnt3(void);
void preset_qcnt3(int);

#ifdef __cplusplus
}
#endif
int qc0, qc1, qc2, qc3;
int qc0_temp, qc1_temp, qc2_temp, qc3_temp;
int update;

void setup() {
  Serial.begin(12345);
  init_qcnt0(0);
  init_qcnt1(0);
  init_qcnt2(0);
  init_qcnt3(100);                    // preset value = 100
//  set_index1_pol(1);
}

void loop() {
  update = 0;   
  qc0 = read_qcnt0();                 // read
  qc1 = read_qcnt1();                 // read
  qc2 = read_qcnt2();                 // read
  qc3 = read_qcnt3();                 // read
  if(qc0 != qc0_temp) {               // compare new != old
    qc0_temp = qc0;                   // old = new 
    update = 1;
  }  
  if(qc1 != qc1_temp) {               // compare new != old
    qc1_temp = qc1;                   // old = new 
    update = 1;
  }  
  if(qc2 != qc2_temp) {               // compare new != old
    qc2_temp = qc2;                   // old = new 
    update = 1;
  }  
  if(qc3 != qc3_temp) {               // compare new != old
    qc3_temp = qc3;                   // old = new 
    update = 1;
  }  
  if(update) {
    Serial.print("CH0: ");
    Serial.print(qc0);
    Serial.print("  CH1: ");
    Serial.print(qc1);
    Serial.print("  CH2: ");
    Serial.print(qc2);
    Serial.print("  CH3: ");
    Serial.println(qc3);
  }

  delay(10); 
}
